import { Feature } from "../../private/Feature";
export declare class RunNextRoom extends Feature {
    vConditionalFunc: () => boolean;
    private readonly postNewRoomReordered;
    /**
     * Supply a function to run on the next `POST_NEW_ROOM` callback.
     *
     * Note that this function will not handle saving and quitting. If a player saving and quitting
     * before the deferred function fires would cause a bug in your mod, then you should handle
     * deferred functions manually using serializable data.
     *
     * In order to use this function, you must upgrade your mod with `ISCFeature.RUN_NEXT_ROOM`.
     */
    runNextRoom(func: () => void): void;
}
//# sourceMappingURL=RunNextRoom.d.ts.map