/// <reference types="isaac-typescript-definitions" />
/// <reference types="isaac-typescript-definitions" />
/// <reference types="isaac-typescript-definitions" />
/// <reference types="isaac-typescript-definitions" />
/**
 * A cached version of the class returned from the `Game()` constructor.
 *
 * Use this instead of invoking the constructor again for a miniscule performance increase.
 *
 * Caching the results of this constructor is safe, but caching other classes (like `Level` or
 * `Room`) is not safe and can lead to the game crashing in certain situations.
 */
export declare const game: Game;
/**
 * A cached version of the class returned from the `Isaac.GetItemConfig()` constructor.
 *
 * Use this instead of invoking the constructor again for a miniscule performance increase.
 *
 * Caching the results of this constructor is safe, but caching other classes (like `Level` or
 * `Room`) is not safe and can lead to the game crashing in certain situations.
 */
export declare const itemConfig: ItemConfig;
/**
 * A cached version of the class returned from the `MusicManager()` constructor.
 *
 * Use this instead of invoking the constructor again for a miniscule performance increase.
 *
 * Caching the results of this constructor is safe, but caching other classes (like `Level` or
 * `Room`) is not safe and can lead to the game crashing in certain situations.
 */
export declare const musicManager: MusicManager;
/**
 * A cached version of the class returned from the `SFXManager()` constructor.
 *
 * Use this instead of invoking the constructor again for a miniscule performance increase.
 *
 * Caching the results of this constructor is safe, but caching other classes (like `Level` or
 * `Room`) is not safe and can lead to the game crashing in certain situations.
 */
export declare const sfxManager: SFXManager;
/**
 * An object containing all 7 vanilla fonts that are pre-loaded and ready to use.
 *
 * For more information on the vanilla fonts and to see what they look like, see:
 * https://wofsauge.github.io/IsaacDocs/rep/tutorials/Tutorial-Rendertext.html
 */
export declare const fonts: {
    readonly droid: Font;
    readonly pfTempestaSevenCondensed: Font;
    readonly teamMeatFont10: Font;
    readonly teamMeatFont12: Font;
    readonly teamMeatFont16Bold: Font;
    readonly terminus: Font;
    readonly upheaval: Font;
};
//# sourceMappingURL=cachedClasses.d.ts.map