/// <reference types="@typescript-to-lua/language-extensions" />
/**
 * Helper function to get a set containing all of the global variable names that are contained
 * within the Isaac environment by default.
 *
 * Returns a slightly different set depending on whether the "--luadebug" flag is enabled.
 */
export declare function getDefaultGlobals(): ReadonlySet<string>;
/**
 * Helper function to get an array of any added global variables in the Isaac Lua environment.
 * Returns a sorted array of key/value tuples.
 */
export declare function getNewGlobals(): ReadonlyArray<[AnyNotNil, unknown]>;
/** Helper function to log any added global variables in the Isaac Lua environment. */
export declare function logNewGlobals(): void;
/**
 * Converts every `isaacscript-common` function that begins with "log" to a global function.
 *
 * This is useful when printing out variables from the in-game debug console.
 */
export declare function setLogFunctionsGlobal(): void;
/**
 * Sets the `traceback` and `getTraceback` functions to be global functions.
 *
 * This is useful when editing Lua files when troubleshooting.
 */
export declare function setTracebackFunctionsGlobal(): void;
//# sourceMappingURL=globals.d.ts.map