import { Challenge, PlayerType } from "isaac-typescript-definitions";

export const DEFAULT_CHALLENGE_CHARACTER = PlayerType.ISAAC;

/**
 * Contains the starting character for each challenge.
 *
 * Taken from the "challenges.xml" file.
 */
export const CHALLENGE_CHARACTERS = {
  [Challenge.NULL]: DEFAULT_CHALLENGE_CHARACTER, // 0
  [Challenge.PITCH_BLACK]: DEFAULT_CHALLENGE_CHARACTER, // 1
  [Challenge.HIGH_BROW]: DEFAULT_CHALLENGE_CHARACTER, // 2
  [Challenge.HEAD_TRAUMA]: DEFAULT_CHALLENGE_CHARACTER, // 3
  [Challenge.DARKNESS_FALLS]: PlayerType.EVE, // 4
  [Challenge.TANK]: PlayerType.MAGDALENE, // 5
  [Challenge.SOLAR_SYSTEM]: DEFAULT_CHALLENGE_CHARACTER, // 6
  [Challenge.SUICIDE_KING]: PlayerType.LAZARUS, // 7
  [Challenge.CAT_GOT_YOUR_TONGUE]: DEFAULT_CHALLENGE_CHARACTER, // 8
  [Challenge.DEMO_MAN]: DEFAULT_CHALLENGE_CHARACTER, // 9
  [Challenge.CURSED]: PlayerType.MAGDALENE, // 10
  [Challenge.GLASS_CANNON]: PlayerType.JUDAS, // 11
  [Challenge.WHEN_LIFE_GIVES_YOU_LEMONS]: DEFAULT_CHALLENGE_CHARACTER, // 12
  [Challenge.BEANS]: DEFAULT_CHALLENGE_CHARACTER, // 13
  [Challenge.ITS_IN_THE_CARDS]: DEFAULT_CHALLENGE_CHARACTER, // 14
  [Challenge.SLOW_ROLL]: DEFAULT_CHALLENGE_CHARACTER, // 15
  [Challenge.COMPUTER_SAVY]: DEFAULT_CHALLENGE_CHARACTER, // 16
  [Challenge.WAKA_WAKA]: DEFAULT_CHALLENGE_CHARACTER, // 17
  [Challenge.HOST]: DEFAULT_CHALLENGE_CHARACTER, // 18
  [Challenge.FAMILY_MAN]: DEFAULT_CHALLENGE_CHARACTER, // 19
  [Challenge.PURIST]: DEFAULT_CHALLENGE_CHARACTER, // 20
  [Challenge.XXXXXXXXL]: DEFAULT_CHALLENGE_CHARACTER, // 21
  [Challenge.SPEED]: DEFAULT_CHALLENGE_CHARACTER, // 22
  [Challenge.BLUE_BOMBER]: PlayerType.BLUE_BABY, // 23
  [Challenge.PAY_TO_PLAY]: DEFAULT_CHALLENGE_CHARACTER, // 24
  [Challenge.HAVE_A_HEART]: DEFAULT_CHALLENGE_CHARACTER, // 25
  [Challenge.I_RULE]: DEFAULT_CHALLENGE_CHARACTER, // 26
  [Challenge.BRAINS]: PlayerType.BLUE_BABY, // 27
  [Challenge.PRIDE_DAY]: DEFAULT_CHALLENGE_CHARACTER, // 28
  [Challenge.ONANS_STREAK]: PlayerType.JUDAS, // 29
  [Challenge.GUARDIAN]: DEFAULT_CHALLENGE_CHARACTER, // 30
  [Challenge.BACKASSWARDS]: DEFAULT_CHALLENGE_CHARACTER, // 31
  [Challenge.APRILS_FOOL]: DEFAULT_CHALLENGE_CHARACTER, // 32
  [Challenge.POKEY_MANS]: DEFAULT_CHALLENGE_CHARACTER, // 33
  [Challenge.ULTRA_HARD]: DEFAULT_CHALLENGE_CHARACTER, // 34
  [Challenge.PONG]: DEFAULT_CHALLENGE_CHARACTER, // 35
  [Challenge.SCAT_MAN]: DEFAULT_CHALLENGE_CHARACTER, // 36
  [Challenge.BLOODY_MARY]: PlayerType.BETHANY, // 37
  [Challenge.BAPTISM_BY_FIRE]: PlayerType.BETHANY, // 38
  [Challenge.ISAACS_AWAKENING]: DEFAULT_CHALLENGE_CHARACTER, // 39
  [Challenge.SEEING_DOUBLE]: PlayerType.JACOB, // 40
  [Challenge.PICA_RUN]: DEFAULT_CHALLENGE_CHARACTER, // 41
  [Challenge.HOT_POTATO]: PlayerType.FORGOTTEN_B, // 42
  [Challenge.CANTRIPPED]: PlayerType.CAIN_B, // 43
  [Challenge.RED_REDEMPTION]: PlayerType.JACOB_B, // 44
  [Challenge.DELETE_THIS]: DEFAULT_CHALLENGE_CHARACTER, // 45
} as const satisfies Record<Challenge, PlayerType>;
